#pragma once

#include <stdio.h>
#include <wchar.h>
#include <stdlib.h>

#include <string>
using namespace std;

#ifdef LINUX

#include <memory.h>
#include <unistd.h> 
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>


#ifndef VOID
#define VOID void
typedef char CHAR;
typedef short SHORT;
typedef long LONG;
#endif

#undef FALSE
#undef TRUE
#undef NULL
#define FALSE   0
#define TRUE    1
#define NULL    0

#ifdef UNICODE     
#define _T L##     
#define TCHAR  wchar_t
#define _tprintf wprintf  
#define _tcslen  wcslen
#define _stprintf  swprintf
#define _tcslen		wcslen
#define _tcscmp  wcscmp
#define _tfopen  _wfopen
#define _tcsstr  wcsstr
#define _tcscat  wcscat
#define _taccess    access
#define _tcstoul    wcstoul
#define _tcsrchr        wcsrchr
#define _tcscpy         wcscpy
#define _tcsncpy   wcsncpy
#define _ttoi    _wtoi
#define _vstprintf vswprintf
#define _trename _wrename
#else     
#define _T    
#define TCHAR   char
#define _tprintf printf   
#define _tcslen  strlen
#define _stprintf  sprintf
#define _tcslen		strlen
#define _tcscmp  strcmp
#define _tfopen  fopen
#define _tcsstr   strstr
#define _tcscat   strcat
#define _taccess   access
#define _tcstoul    strtoul
#define _tcsrchr        strrchr
#define _tcscpy         strcpy
#define _tcsncpy   strncpy
#define _ttoi    atoi
#define _vstprintf vsprintf
#define _trename  rename
#endif  

#endif




#ifdef UNICODE
#define tstring wstring
#define tsprintf  swprintf
#define taccess   _waccess
#define tatoi     _wtoi
#define tsscanf     swscanf
#define tstringstream     wstringstream
#define ttolower     towlower
#define ttoupper     towupper
#define tfprintf     fwprintf
#define tprintf      wprintf
#define tofstream wofstream
#define tifstream wifstream
#define t_splitpath_s  _wsplitpath_s
#define tstringstream   wstringstream

#else
#define tstring string
#define tsprintf  sprintf
#define taccess   access
#define tatoi     atoi
#define tsscanf     sscanf
#define tstringstream     stringstream
#define ttolower     tolower
#define ttoupper     toupper
#define tfprintf     fprintf
#define tprintf      printf
#define tofstream ofstream
#define tifstream ifstream
#define t_splitpath_s  _splitpath_s
#define tstringstream   stringstream
#endif


